//
//  HeadersH1NoButtonsBodyTextModel.swift
//  MVMCoreUI
//
//  Created by Subhankar Acharya on 13/07/20.
//  Copyright © 2020 Verizon Wireless. All rights reserved.
//



public class HeadersH1NoButtonsBodyTextModel: HeaderModel, MoleculeModelProtocol {
    //--------------------------------------------------
    // MARK: - Properties
    //--------------------------------------------------
    
    public static var identifier: String = "headerH1"
    public var headlineBody: HeadlineBodyModel
    
    //--------------------------------------------------
    // MARK: - Initializer
    //--------------------------------------------------
    
    public init(headlineBody: HeadlineBodyModel) {
        self.headlineBody = headlineBody
        super.init()
    }
    
    //--------------------------------------------------
    // MARK: - Keys
    //--------------------------------------------------
    private enum CodingKeys: String, CodingKey {
        case moleculeName
        case headlineBody
    }
    
    //--------------------------------------------------
    // MARK: - Codec
    //--------------------------------------------------
    required public init(from decoder: Decoder) throws {
        let typeContainer = try decoder.container(keyedBy: CodingKeys.self)
        headlineBody = try typeContainer.decode(HeadlineBodyModel.self, forKey: .headlineBody)
        try super.init(from: decoder)
    }
    
    public override func encode(to encoder: Encoder) throws {
        try super.encode(to: encoder)
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(moleculeName, forKey: .moleculeName)
        try container.encode(headlineBody, forKey: .headlineBody)
    }
}
